
from abc import abstractmethod
from typing import List, Dict

from o_types import *

class Agent():

	def process_result():
		pass

	# hier die Kommunikation mit dem Management Server

""" ===== """

class ProcessAgent(Agent):
	TYPE:str = None

	@abstractmethod
	def on_process_data(self, data:List[Data]):
		pass

class TextAgentExample(ProcessAgent):
	TYPE = Data.TYPE_TEXT
	def on_process_data(self, data:List[Data]):
		# Studi Code
		self.process_result(Data(...))
		
class ImageAgentExample(ProcessAgent):
	TYPE = Data.TYPE_IMAGE

class AudioAgentExample(ProcessAgent):
	TYPE = Data.TYPE_AUDIO
	
""" ===== """

class SolveAgent(Agent):
	
	@abstractmethod
	def on_riddle_data(self, riddle:Riddle, data:List[Data]):
		pass

		# Studi Code

		self.new_riddle(Riddle('x', 'y', 'z'))
		self.send_riddle_result(...)

""" ===== """

class GatekeeperAgent(Agent):
	
	@abstractmethod
	def on_result_check(self, xyz):

		# Studi Code
		
		self.send_check_result(accept=True|False, ...)